variables:
  VERSION: $CI_COMMIT_SHORT_SHA
  DOCKER_IMAGE: $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA

stages:
    ['package','build','test','deploy']

package:
  stage: package
  image: maven:3-jdk-8-alpine
  script:
    - mvn package --no-transfer-progress -Dapp.version=$VERSION -DskipTests=true
  artifacts:
    paths:
      - target/*.jar
    expire_in: 1 hour

  
build:
    stage: build
    image: docker:latest
    services:
    - docker:dind
    before_script:
    - echo "Building"
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    script:         
    - cp target/*.jar .
    - docker build --build-arg VERSION=$VERSION -t $DOCKER_IMAGE .
    - docker push $DOCKER_IMAGE
    - docker container prune -f
    - docker rmi -f $DOCKER_IMAGE

test:
    stage: test
    image: maven:3-jdk-8-alpine
    script:        
      - mvn verify -Dapp.version=$VERSION --no-transfer-progress

deploy:
  stage: deploy
  image: dtzar/helm-kubectl
  before_script:
    - apk add gettext
    - export KUBECONFIG=${K8S_CONFIG}
  script:
    - SPRING_PROFILES_ACTIVE=prod REPLICA=1 envsubst < k8s.yml | kubectl apply --record=true -f -
    - kubectl rollout status deployments/${CI_PROJECT_NAME}-deployment -n=${K8S_NAMESPACE}


        


